// XCASHelpReaderDlg.cpp : implementation file
//
/*
	Copyright  G. Mason,2005

	This file is part of XCAS Help Reader

    XCAS Reader is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    XCAS Reader is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with XCAS Reader; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	


*/




#include "stdafx.h"
#include "XCASHelpReader.h"
#include "XCASHelpReaderDlg.h"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CFile myfile;
extern char* buffer;

long findfileptr;
bool findstarting;
long findlastlistitem;

// ---- MODIFIED: June 15,2006
char language='2';
HICON m_hIconS;			// hack to get a nice small icon in the task bar

/////////////////////////////////////////////////////////////////////////////
// CXCASHelpReaderDlg dialog

CXCASHelpReaderDlg::CXCASHelpReaderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXCASHelpReaderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXCASHelpReaderDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);\
	m_hIconS = AfxGetApp()->LoadIcon(IDR_MAINFRAME1);
}

void CXCASHelpReaderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXCASHelpReaderDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXCASHelpReaderDlg, CDialog)
	//{{AFX_MSG_MAP(CXCASHelpReaderDlg)
	ON_LBN_SELCHANGE(IDC_KEYWORDS, OnSelchangeKeywords)
	ON_CBN_SELCHANGE(IDC_ALSOSEE, OnSelchangeAlsosee)
	ON_BN_CLICKED(IDC_COPYTXT, OnCopytxt)
	ON_BN_CLICKED(IDC_FIND, OnFind)
	ON_EN_CHANGE(IDC_FINDME, OnChangeFindme)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO1, OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnBnClickedRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnBnClickedRadio3)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXCASHelpReaderDlg message handlers

BOOL CXCASHelpReaderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIconS, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
	long i,j;
	char* textchar;
	char* startchar;
	char* endchar;
	TCHAR tstring[500];
	CListBox*  listbox = (CListBox*) GetDlgItem(IDC_KEYWORDS);
	bool endpending;
	// open the file

	CButton* rbut= (CButton*) GetDlgItem(IDC_RADIO2);
	rbut->SetCheck(BST_CHECKED);

	listbox->SetRedraw(false);

		// read in and parce the file for key words
		i=myfile.Read(buffer,BUFFERSIZE);
		buffer[BUFFERSIZE]=0;
		textchar = buffer;
		endpending=false;

		do { // scan through all of the file

			for(;;) {  // scan through all of the buffer

				// find a #
				startchar = strchr(textchar,'#');
				if (startchar){

					// find the CR
					endchar = strchr(startchar,10);

					if (endchar){
						textchar = endchar;
						*endchar++ = 0;
						MultiByteToWideChar(CP_ACP,0,startchar+2,-1,tstring,500);
						j=listbox->AddString(tstring);
						listbox->SetItemData(j,myfile.GetPosition()+(DWORD)endchar- (DWORD)buffer-i);

						endchar = strstr(endchar,"\n\n#");
						if (endchar) {
							textchar = endchar;
						} else {
							// no \n, so must be in the next file segment
							endpending = true;
							break;
						}
						
					} else {
						// found a # with no 0 pair, must have aplit the pairs
						myfile.Seek(-50,CFile::current);
						// assumes no keywords greater than 50 characters
						break;
					}

				} else {
					// all done, with this group
					break;
				}
			}


			i=myfile.Read(buffer,BUFFERSIZE);
			buffer[i]=0;

			if (endpending){
				textchar = strstr(buffer,"\n\n#");
				if (!textchar)
					i=0;  // force a quit
			} else 
				textchar = buffer;

		} while (i != 0);



	listbox->SetRedraw(true);

	OnChangeFindme(); 
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CXCASHelpReaderDlg::OnSelchangeKeywords() 
{
	// tapped on a command in the list.  Find the corresponding text and parse it

	// TODO: Add your control notification handler code here
	CListBox*  listbox = (CListBox*) GetDlgItem(IDC_KEYWORDS);
	CEdit* editbox = (CEdit*) GetDlgItem(IDC_HELPTEXT);
	CComboBox* alsosee = (CComboBox*) GetDlgItem(IDC_ALSOSEE);
	char* starttext;
	char* endtext;
	TCHAR tstring[1000];
	TCHAR ustr[100];

	long data;
	long cursel;


	cursel = listbox->GetCurSel();
	data = listbox->GetItemData(cursel);

	myfile.Seek(data,CFile::begin);
	// get english, so skip over the first item

// ---- MODIFIED: June 15,2006
	myfile.Read(&buffer[1],BUFFERSIZE);

	starttext=buffer;
	buffer[0]=9;
	for (short i=1;i<=3;i++) {
		if (starttext && (starttext[1]==language))
			break;
		else
			starttext = strchr(starttext+1,10);
	}


//	starttext = strchr(buffer,10);
	if (starttext && (starttext[1]==language)){
		// found the english section
		starttext +=3;
		endtext = strchr(starttext,10);
		if (endtext){

			// this gets a little sloppy and assumes the help file is properly formatted

			// mark the end of the help
			*endtext++=0;

			// convert to unicode and display
			data=MultiByteToWideChar(CP_ACP,0,starttext,-1,tstring,1000)-1;

			// get the parameters
			starttext = strstr(endtext,"\n0")+3;
			endtext = strchr(starttext,'\n');
			*endtext++=0;

			data+=_stprintf(&tstring[data],TEXT("\r\n\r\nParams:"));
			data+=MultiByteToWideChar(CP_ACP,0,starttext,-1,&tstring[data],1000-data)-1;

			// scan past "also see"
			starttext=endtext;
			alsosee->ResetContent();
			alsosee->EnableWindow(false);
			while(starttext[0] == '-'){
				// load up the "also see list"
				endtext = strchr(starttext,'\n');
				*endtext=0;
				MultiByteToWideChar(CP_ACP,0,starttext+3,-1,ustr,100);

				if (listbox->FindString(-1,ustr) != LB_ERR) {
					alsosee->AddString(ustr);
					alsosee->EnableWindow(true);
				}
				starttext = endtext+1;
				//starttext = strchr(starttext,'\n')+1;
			}


			data+=_stprintf(&tstring[data],TEXT("\r\n\r\nExamples:\r\n"));
			
			if (starttext[0] == '\n') // already at the end, so get rid of the Example text
				tstring[data-15]=0;
			// scan in examples one line at a time

			while(starttext[0] != '\n'){ // stop at the double return
				endtext = strchr(starttext,'\n');
				*endtext = 0;
				data+=MultiByteToWideChar(CP_ACP,0,starttext,-1,&tstring[data],1000-data)-1;
				data+=_stprintf(&tstring[data],TEXT("\r\n"));
				starttext = endtext+1;

			}

			editbox->SetWindowText(tstring);

		}
	}
}

void CXCASHelpReaderDlg::OnSelchangeAlsosee() 
{
	// TODO: Add your control notification handler code here
	CListBox*  listbox = (CListBox*) GetDlgItem(IDC_KEYWORDS);
	CComboBox* alsosee = (CComboBox*) GetDlgItem(IDC_ALSOSEE);
	long sel;
	CString theStr;

	alsosee->GetLBText(alsosee->GetCurSel(),theStr);

	sel=listbox->FindString(-1,theStr);
	if(sel != LB_ERR) {
		listbox->SetCurSel(sel);
		OnSelchangeKeywords();

	}

}

void CXCASHelpReaderDlg::OnCopytxt() 
{
	// TODO: Add your control notification handler code here
	CEdit* editbox = (CEdit*) GetDlgItem(IDC_HELPTEXT);
		editbox->Copy();

}


void CXCASHelpReaderDlg::OnFind() 
{
	// TODO: Add your control notification handler code here
	
	CEdit* editbox = (CEdit*) GetDlgItem(IDC_FINDME);
	CListBox*  listbox = (CListBox*) GetDlgItem(IDC_KEYWORDS);
	CButton*   findbut= (CButton*) GetDlgItem(IDC_FIND);
	
	TCHAR ufindtext[50];
	char findtext[50];
	char* findloc;
	char* scanptr;
	char* scanend;
	char* startscan;
	short i;
	bool  notenglish;
	long  segmentSize;
	//	bool findagain;
	
	editbox->GetWindowText(ufindtext,50);
	
	if (ufindtext[0] == 0) return; // nothing to find
	
	WideCharToMultiByte(CP_ACP,0,ufindtext,-1,findtext,50,NULL,NULL);
	
	
	if (findstarting) {
		findfileptr=0;
		findbut->SetWindowText(TEXT("Next"));
		findlastlistitem = 0x8FFFFFFF; // dummy value
		findstarting=false;
	}
	
	for (;;){
		// keep going until a match is found or the end of file 
		if (findfileptr >= myfile.GetLength())
			i=0; // past the end of the file
		else {
			myfile.Seek(findfileptr,CFile::begin);
			i=myfile.Read(buffer,BUFFERSIZE);
		}

		if (i<=20) {
			// end of search
			findstarting=true;
			findbut->SetWindowText(TEXT("Find"));
			MessageBox(TEXT("Search completed"));
			findlastlistitem = 0x8FFFFFFF; // dummy value
			return;
		}
		
		buffer[i]=0;
		// trim the end of the buffer back to guarentee that whole help segments are loaded
		
		scanptr = buffer+i-1; // end of buffer
		
		
		// scan backwards for a \n\n
		while (*scanptr != 0) { 
			if ((*scanptr == 10) && (*(scanptr+1) == 10)) 
				break;
			scanptr--;
		}
		
		*(scanptr+2) = 0;  // end of the buffer, leave the \n\n 
		
		// set up next file start location
		segmentSize= long(scanptr-buffer);
		
		startscan = buffer;
		do {
			// start scan
			findloc = strstr(startscan,findtext);
			if (findloc) {
				// found a match
				// figure out what command this corresponds to
				// scan backwards for a #
				
				scanptr = findloc;
				notenglish=false; // assume english


				// scan backward for the next \n and check the language

// ---- MODIFIED: June 15,2006
				while ((*scanptr != '#') && (scanptr != buffer)) {
				//	while ((*scanptr != '#') && (*scanptr != 10)) { // oops
// ----

					if (*scanptr == 10) {
						// found the first \n backward
						// along the way look a language marker
						if (*(scanptr+1) != language)
						{
							// not in english so ignore this item;
							notenglish=true;
						}
						break; // get out at the first \n or #
					}
					scanptr--;
				}

				if (!notenglish) {
					// is in english
					// scan backward to the first # to extract the key word
					while (*scanptr != '#')
						scanptr--;


					scanend = strchr(scanptr,10);
					if (scanend==NULL) return;

					*scanend=0;
					
					MultiByteToWideChar(CP_ACP,0,scanptr+2,-1,ufindtext,50);
					
					i=listbox->FindString(-1,ufindtext);
					
					if (i!= LB_ERR) {
						// found a valid match,
						
						// scan on past the end of the section to set up for the next search
						scanend = strstr(scanend+1,"\n\n");
						
						findfileptr += scanend-buffer;
						listbox->SetCurSel(i);
						OnSelchangeKeywords();

						
						return;
					} 
				} else
					startscan = findloc + strlen(findtext); // found a match that's not in english, so keep scanning
			}// end IF found
			findfileptr += segmentSize;
		} while (findloc);// end DO
		
	} // end for
	
}

void CXCASHelpReaderDlg::OnChangeFindme() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	CButton*   findbut;

	if (!findstarting) {
		findbut= (CButton*) GetDlgItem(IDC_FIND);
		findstarting=true;
		findbut->SetWindowText(TEXT("Find"));
		findlastlistitem = 0x8FFFFFFF; // dummy value
	}

}



// ---- MODIFIED: June 15,2006

void CXCASHelpReaderDlg::OnBnClickedRadio1()
{
	// TODO: Add your control notification handler code here
	language = '1';
	OnSelchangeKeywords();
}

void CXCASHelpReaderDlg::OnBnClickedRadio2()
{
	// TODO: Add your control notification handler code here
		language = '2';
	OnSelchangeKeywords();

}

void CXCASHelpReaderDlg::OnBnClickedRadio3()
{
	// TODO: Add your control notification handler code here
		language = '3';
	OnSelchangeKeywords();

}


void CXCASHelpReaderDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	MessageBox(TEXT("Xcas Help Reader is designed to read Xcas aide files and is licensed under the GNU General Public License\n\nInformation on Xcas is available at www-fourier.ujif-grenoble.fr/~parisse/giac.html\n\nThis reader is copyrighted 2006 G. Mason (www.statsnow.net)"));
}
